# The LearningOnline Network with CAPA
# Tags Default Definition Module 
#
# last modified 06/26/00 by Alexander Sakharuk

package Apache::londefdef; 

use strict;
use Apache::lonxml;

sub BEGIN {
    &Apache::lonxml::register('Apache::londefdef',('m','html','head','map','applet','select','option','input','textarea','form','meta','title','body','center','b','strong','table','dt','h1','h2','h3','h4','h5','h6','cite','i','address','dd','dl','dir','ol','ul','menu','dfn','kbd','tt','code','em','q','p','br','big','small','basefont','font','s','sub','strike','sup','hr','a','li','u'));
}

#===================================================================== TAG SUBROUTINES
#-- <m> tag
        sub start_m {
	    my ($target,$token,$parstack,$parser) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
		my $inside = $parser->get_text("/m");
                $currentstring = &Apache::lontexconvert::converted('\\documentstyle{article}'.$inside);
	    } elsif ($target eq 'tex') {
              $currentstring = "\$";
            }
	   return $currentstring;
	}
        sub end_m {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
            } elsif ($target eq 'tex') {
              $currentstring = "\$";
            }
	   return $currentstring;
	}
#-------------------------------------------------------------------------- <html> tag    
      sub start_html {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_html {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-------------------------------------------------------------------------- <head> tag
      sub start_head {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_head {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#--------------------------------------------------------------------------- <map> tag
      sub start_map {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_map {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#------------------------------------------------------------------------ <applet> tag
      sub start_applet {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_applet {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#------------------------------------------------------------------------ <select> tag
      sub start_select {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_select {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#------------------------------------------------------------------------ <option> tag
      sub start_option {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_option {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#------------------------------------------------------------------------- <input> tag
      sub start_input {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_input {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#---------------------------------------------------------------------- <textarea> tag
      sub start_textarea {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_textarea {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-------------------------------------------------------------------------- <form> tag
      sub start_form {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_form {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#------------------------------------------------------------------------- <title> tag
      sub start_title {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    }
	   return $currentstring;
	}
        sub end_title {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-------------------------------------------------------------------------- <meta> tag
      sub start_meta {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    }
	   return $currentstring;
	}
        sub end_meta {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#-------------------------------------------------------------------------- <body> tag
        sub start_body {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{document} ";  
	    } 
	   return $currentstring;
	}
        sub end_body {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{document}";  
	    } 
	   return $currentstring;
	}
#------------------------------------------------------------------------ <center> tag
        sub start_center {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{center} ";  
	    } 
	   return $currentstring;
	}
        sub end_center {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{center}";  
	    } 
	   return $currentstring;
	}
#----------------------------------------------------------------------------- <b> tag
        sub start_b {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " {\\bf ";  
	    } 
	   return $currentstring;
	}
        sub end_b {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = "}";  
	    } 
	   return $currentstring;
	}
#------------------------------------------------------------------------ <strong> tag
        sub start_strong {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " {\\bf ";  
	    } 
	   return $currentstring;
	}
        sub end_strong {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {

              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = "}";  
	    } 
	   return $currentstring;
	}
#---------------------------------------------------------------------------- <h1> tag
        sub start_h1 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\chapter{ ";
	    } 
           return $currentstring;
	}
        sub end_h1 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <h2> tag
        sub start_h2 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\section{ ";
	    } 
           return $currentstring;
	}
        sub end_h2 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <h3> tag
        sub start_h3 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\subsection{ ";
	    } 
           return $currentstring;
	}
        sub end_h3 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <h4> tag
        sub start_h4 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\subsubsection{ ";
	    } 
           return $currentstring;
	}
        sub end_h4 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <h5> tag
        sub start_h5 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\paragraph{ ";
	    } 
           return $currentstring;
	}
        sub end_h5 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <h6> tag
        sub start_h6 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\subparagraph{ ";
	    } 
           return $currentstring;
	}
        sub end_h6 {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#-------------------------------------------------------------------------- <cite> tag
        sub start_cite {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\it ";
	    } 
           return $currentstring;
	}
        sub end_cite {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#----------------------------------------------------------------------------- <i> tag
        sub start_i {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\it ";
	    } 
           return $currentstring;
	}
        sub end_i {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#----------------------------------------------------------------------- <address> tag
        sub start_address {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\it ";
	    } 
           return $currentstring;
	}
        sub end_address {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    }
           return $currentstring;
	}
#--------------------------------------------------------------------------- <dfn> tag
        sub start_dfn {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\it ";
	    } 
           return $currentstring;
	}
        sub end_dfn {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <tt> tag
        sub start_tt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\tt ";
	    } 
           return $currentstring;
	}
        sub end_tt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <kbd> tag
        sub start_kbd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\tt ";
	    } 
           return $currentstring;
	}
        sub end_kbd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#-------------------------------------------------------------------------- <code> tag
        sub start_code {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\tt ";
	    } 
           return $currentstring;
	}
        sub end_code {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#---------------------------------------------------------------------------- <em> tag
        sub start_em {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\emph ";
	    } 
           return $currentstring;
	}
        sub end_em {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#----------------------------------------------------------------------------- <q> tag
        sub start_q {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{ \\emph ";
	    } 
           return $currentstring;
	}
        sub end_q {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
		$currentstring .= "}";
	    } 
           return $currentstring;
	}
#----------------------------------------------------------------------------- <p> tag
        sub start_p {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\par ";
	    } 
           return $currentstring;
	}
        sub end_p {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#---------------------------------------------------------------------------- <br> tag
        sub start_br {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\\\";
	    } 
           return $currentstring;
	}
        sub end_br {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    }
           return $currentstring;
	}
#--------------------------------------------------------------------------- <big> tag
        sub start_big {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\large ";
	    } 
           return $currentstring;
	}
        sub end_big {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#------------------------------------------------------------------------- <small> tag
        sub start_small {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\footnotesize ";
	    } 
           return $currentstring;
	}
        sub end_small {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#---------------------------------------------------------------------- <basefont> tag
      sub start_basefont {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
#-------------------------------------------------------------------------- <font> tag
         sub start_font {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_font {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	} 
#------------------------------------------------------------------------ <strike> tag
        sub start_strike {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\underline ";
	    } 
           return $currentstring;
	}
        sub end_strike {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#----------------------------------------------------------------------------- <s> tag
        sub start_s {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\underline ";
	    } 
           return $currentstring;
	}
        sub end_s {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#--------------------------------------------------------------------------- <sub> tag
        sub start_sub {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\$_{ ";
	    } 
           return $currentstring;
	}
        sub end_sub {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }\$";
            }
           return $currentstring;
	}
#--------------------------------------------------------------------------- <sup> tag
        sub start_sup {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\$^{ ";
	    } 
           return $currentstring;
	}
        sub end_sup {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }\$";
            }
           return $currentstring;
	}
#---------------------------------------------------------------------------- <hr> tag
        sub start_hr {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "\\hline ";
	    } 
           return $currentstring;
	}
#----------------------------------------------------------------------------- <a> tag
        sub start_a {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
	    }
           return $currentstring;
	}
        sub end_a {
	    my ($target,$token,$stackref) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
                my  $tempor_var = $stackref->[$#$stackref];
		if (index($tempor_var,'name') != -1 ) {
		    $tempor_var =~ s/name=([^,]*),/$1/g;
	        $currentstring .= " \\label{$tempor_var}";
	        } elsif (index($tempor_var,'href') != -1 ) {
		    $tempor_var =~ s/href=([^,]*),/$1/g;
	        $currentstring .= " \\ref{$tempor_var}";
	        }
            }
           return $currentstring;
	}
#---------------------------------------------------------------------------- <li> tag
        sub start_li {
	    my ($target,$token,$stackref) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
                my  $tempor_var = $stackref->[$#$stackref-1];
                if (index($tempor_var,'circle') != -1 ) {
	          $currentstring .= " \\item[o] ";
	        } elsif (index($tempor_var,'square') != -1 ) {
	               $currentstring .= " \\item[$\Box$] ";
	        } else {
		    $currentstring .= " \\item ";
	        }  
	    } 
	   return $currentstring;
	}
        sub end_li {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } 
	   return $currentstring;
	}
#----------------------------------------------------------------------------- <u> tag
        sub start_u {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[4];
	    } elsif ($target eq 'tex') {
		$currentstring .= "{\\underline ";
	    } 
           return $currentstring;
	}
        sub end_u {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
	       $currentstring .= $token->[2];
	    } elsif ($target eq 'tex') {
	        $currentstring .= " }";
            }
           return $currentstring;
	}
#---------------------------------------------------------------------------- <ul> tag
        sub start_ul {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{itemize} ";  
	    } 
	   return $currentstring;
	}
        sub end_ul {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{itemize}";  
	    } 
	   return $currentstring;
	}
#-------------------------------------------------------------------------- <menu> tag
        sub start_menu {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{itemize} ";  
	    } 
	   return $currentstring;
	}
        sub end_menu {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{itemize}";  
	    } 
	   return $currentstring;
	}
#--------------------------------------------------------------------------- <dir> tag
        sub start_dir {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{itemize} ";  
	    } 
	   return $currentstring;
	}
        sub end_dir {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{itemize}";  
	    } 
	   return $currentstring;
	}
#---------------------------------------------------------------------------- <ol> tag
        sub start_ol {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{enumerate} ";  
	    } 
	   return $currentstring;
	}
        sub end_ol {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{enumerate}";  
	    } 
	   return $currentstring;
	}
#---------------------------------------------------------------------------- <dl> tag
        sub start_dl {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{description} ";  
	    } 
	   return $currentstring;
	}
        sub end_dl {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{description}";  
	    } 
	   return $currentstring;
	}
#---------------------------------------------------------------------------- <dt> tag
        sub start_dt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = "\\item[ ";  
	    } 
	   return $currentstring;
	}
        sub end_dt {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } elsif ($target eq 'tex') {
              $currentstring = "]";  
	    } 
	   return $currentstring;
	}
#---------------------------------------------------------------------------- <dd> tag
        sub start_dd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } 
	   return $currentstring;
	}
        sub end_dd {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];    
            } 
	   return $currentstring;
	}
#------------------------------------------------------------------------- <table> tag
        sub start_table {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[4];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\begin{tabular} ";  
	    } 
	   return $currentstring;
	}
        sub end_table {
	    my ($target,$token) = @_;
            my $currentstring = '';
            if ($target eq 'web') {
              $currentstring = $token->[2];     
	    } elsif ($target eq 'tex') {
              $currentstring = " \\end{tabular}";  
	    } 
	   return $currentstring;
	}

1;
__END__
