# The LearningOnline Network with CAPA
# <script> definiton


package Apache::scripttag; 

use strict;
use Apache::lonnet;

sub BEGIN {
  &Apache::lonxml::register('Apache::scripttag',('script','scriptlib',
						 'parserlib','import'));
}

sub start_script {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $result="";
  $safeeval->share('$Apache::scripttag::start_script::result');
#  my $bodytext=$$parser[$#$parser]->get_text("/script");
  my $bodytext=&Apache::lonxml::get_all_text("script",$$parser[$#$parser]);

  if ( $target eq "modified" ) {
    
  }

#  print "<br> script runs $bodytext</br>";
  &Apache::run::run($bodytext,$safeeval);

  if ($target eq "edit" ) {
    $result= "<br> &lt;$token->[1]&gt; output: <br>$bodytext<br>Source:<br>";
    $result.=&editfield($token->[1],$bodytext);
  }
  return $result;
}

sub end_script {}

sub start_scriptlib {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $bodytext=$$parser[$#$parser]->get_text("/scriptlib");
  my $result ="";

  $bodytext=Apache::run::evaluate($bodytext,$safeeval,$$parstack[$#$parstack]);
  &Apache::run::run(&getfile($bodytext),$safeeval);
  #print "ran $bodytext:<br>".&getfile($bodytext)."<br>";

  if ($target eq "edit" ) {
    $result.=&editfield($token->[1],$bodytext);
  }
  return $result;
}

sub end_scriptlib {}

sub start_parserlib {
  my ($target,$token,$parstack,$parser,$safeeval,$style)=@_;
  my $bodytext=$$parser[$#$parser]->get_text("/parserlib");
  my $result ="";

  $bodytext=Apache::run::evaluate($bodytext,$safeeval,$$parstack[$#$parstack]);
  %$style = ( %$style , &Apache::style::styleparser($target, 
		&getfile($bodytext)));

  if ($target eq "edit" ) {
    $result=&editfield($token->[1],$bodytext);
  }
  return $result;
}

sub end_parserlib {
}

sub start_import {
  my ($target,$token,$parstack,$parser,$safeeval,$style)=@_;
  my $bodytext=$$parser[$#$parser]->get_text("/import");
  my $result ="";

  $bodytext=Apache::run::evaluate($bodytext,$safeeval,$$parstack[$#$parstack]);
  my $file=&getfile($bodytext);
  if ($file eq -1) {
    return "<b> Unable to find <i>$bodytext</i> for import</b>";
  }

  my $tempparser=HTML::TokeParser->new(\$file);
  push (@$parser,$tempparser);

  if ($target eq "edit" ) {
    $result.=&editfield($token->[1],$bodytext);
    $result.="Click<a href=\"/res/$bodytext\">here</a> to edit<br></br>"
  }
}

sub end_import {
}

sub editfield {
  my ($tag,$data)=@_;
  
  my $count=0;
  my $maxlength=-1;
  map { $count++;
	if (length($_) > $maxlength) { $maxlength = length ($_); }
      } split ("\n", $data);
	  
  return "<br></br>\n&lt;$tag&gt;<br></br>\n&nbsp;&nbsp;&nbsp;<textarea rows=\"$count\" cols=\"$maxlength\" name=homework_edit_".$Apache::lonxml::curdepth.">$data</textarea><br></br>\n&lt;/$tag&gt;<br></br>\n";
}

sub getfile {
  my ($filename) = @_;
  my $a="";
  
  $filename=~ s/^\s*(\S+)\s*$/$1/; ## strip off leading and trailing spaces
  $filename="/home/httpd/html/res".$filename;
  if (! -e $filename ) {
    &Apache::lonnet::subscribe($filename);
    &Apache::lonnet::repcopy($filename);
  }
  if (! -e $filename ) { return -1; };
  my $fh=Apache::File->new($filename);
  while (<$fh>) {
      $a .=$_;
  }
  return $a
}

1;
__END__
